-------------------------------------------------------------|
---------------HUGE QUEST by RetroStation--------------------|
----------------------and DarkyBenji-------------------------|
-------------------------------------------------------------|
freeslot(
	"sfx_hq",
	"sfx_hqa"
)

---------|
--CVars--|
---------|

rawset(_G, "hq_huge" , CV_RegisterVar({
	name = "hq_huge",
	defaultvalue = "On",
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff
}))

rawset(_G, "hq_orbigift" , CV_RegisterVar({
	name = "hq_orbigift",
	defaultvalue = "Off",
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff
}))

rawset(_G, "hq_yeet" , CV_RegisterVar({
	name = "hq_yeet",
	defaultvalue = "On",
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff
}))

rawset(_G, "hq_offroad" , CV_RegisterVar({
	name = "hq_offroad",
	defaultvalue = "On",
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff
}))
rawset(_G, "hq_mtstore" , CV_RegisterVar({
	name = "hq_mtstore",
	defaultvalue = "On",
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff
}))

rawset(_G, "hq_sparkle" , CV_RegisterVar({
	name = "hq_sparkle",
	defaultvalue = "On",
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff
}))

rawset(_G, "hq_skittles" , CV_RegisterVar({
	name = "hq_skittles",
	defaultvalue = "Off",
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff
}))

rawset(_G, "hq_eggkarma" , CV_RegisterVar({
	name = "hq_eggkarma",
	defaultvalue = "On",
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff
}))

----------------|
--FUCKING PAIN--|
----------------|


local TICRATE = TICRATE
local FRACUNIT = FRACUNIT
--local ANGLE_22h = ANGLE_22h
--local FRACBITS = FRACBITS
local k_sneakertimer = k_sneakertimer
local k_spinouttimer = k_spinouttimer
local k_wipeoutslow = k_wipeoutslow
local k_driftboost = k_driftboost
local k_driftcharge = k_driftcharge
local k_floorboost = k_floorboost
local k_startboost = k_startboost
local k_itemamount = k_itemamount
local k_itemtype = k_itemtype
local k_rocketsneakertimer = k_rocketsneakertimer
local k_hyudorotimer = k_hyudorotimer
local k_drift = k_drift
local k_speedboost = k_speedboost
local k_boostpower = k_boostpower
local k_accelboost = k_accelboost
local k_invincibilitytimer = k_invincibilitytimer
local k_growshrinktimer = k_growshrinktimer
local k_offroad = k_offroad
local k_itemroulette = k_itemroulette
local k_roulettetype = k_roulettetype
local STARTTIME = 6*TICRATE + (3*TICRATE/4)
local pks
--local pks2
--local ghost
--local lastframescale

--Init------|
----And-----|
------Sync--|

local function hq_init(p)
	p.hqready = 1 --midgame sync
	p.huge = 0 -- New Grow timer
	p.hqspeen = false
	p.hqboom = false
	p.hqspb = false
	--prev tics
	p.HQLFitem = 0
	p.HQLFamount = 0
end

------------|
------------|
------------|

local function GrowplusEndCheck(p)
	if p.huge == 1 
	or p.playerstate ~= PST_LIVE 
	or p.pflags & PF_TIMEOVER
	or (p.kartstuff[k_invincibilitytimer] == 0 and p.kartstuff[k_growshrinktimer] < 0) 
	or p.exiting then
	return true
	else return false end
end

--- Music Transition block for new Invincibility and Grow ---
addHook("MusicChange", function(oldmusic, newmusic, flags, looping)
	//print("oldmusic:"..oldmusic.."  newmusic:"..newmusic)
	
	for dp in displayplayers.iterate
		//print("Huge:"..dp.huge.." Sparkle:"..dp.kartstuff[k_invincibilitytimer])
		if GrowplusEndCheck(dp) then continue end
		if (dp.huge and dp.huge > 1) and dp.kartstuff[k_invincibilitytimer] <= 1 //What do you mean the music stop at 1?!
			if not (newmusic == "kgrow")
				return "kgrow", flags, true
			end
		end
	end
end)

--- Grow Reconstruction: Base code by Benji, balance adjustments by RetroStation--- 
local function K_HugeQuest(p)
	if not (hq_huge.value) then return end
	
	pks = p.kartstuff

	if pks[k_growshrinktimer] > 0
		if JUICEBOX
			p.JBlastgst = 0
		end
		p.huge = $+(pks[k_growshrinktimer]+1)
		
		pks[k_growshrinktimer] = 0
		//print("timer:"..p.huge)
		//print("HUGE QUEST")
	end

	if p.huge > 1 
	and not p.exiting then
		p.huge = max($-1, 0)
		pks[k_speedboost] = max($, growplus.speedmod)
		
		if hq_offroad.value
			pks[k_offroad] = 0
			if S_SoundPlaying(p.mo, sfx_cdfm70) --delete offroad sound
				S_StopSoundByID(p.mo, sfx_cdfm70)
			end
			pks[k_boostpower] = max($, FRACUNIT)
		end
		
		
		if pks[k_hyudorotimer]
			pks[k_hyudorotimer] = 0
			p.powers[pw_flashing] = 0 
			if kmp != nil 
			and kmp_extendflashtics.value then 
				p.mo.K_fakeflashing = 0
			end //lol KartMP
		end
			
		if not pks[k_invincibilitytimer]
			if p.huge%(TICRATE/7) == 0 
				if hq_offroad.value
					p.mo.color = SKINCOLOR_TEA
				else
					p.mo.color = SKINCOLOR_PERIWINKLE
				end
				p.mo.colorized = true
			else
				p.mo.color = p.skincolor
				p.mo.colorized = false
			end
		end
		
		if pks[k_roulettetype] == 2
			pks[k_roulettetype] = 1
		end

		if pks[k_itemblink] == TICRATE
			if pks[k_itemtype] == 1 then 
				pks[k_itemtype] = 6 end
			if pks[k_itemtype] == 5 then
				pks[k_itemtype] = 8 end
			if pks[k_itemtype] == 2 then
				pks[k_itemtype] = 3 end
			if pks[k_itemtype] == 14 then 
				if P_RandomChance(FRACUNIT/50)
					pks[k_itemtype] = 16
				else
					if P_RandomChance(FRACUNIT/2)
						pks[k_itemtype] = 6
						pks[k_itemamount] = 4
					else
						pks[k_itemtype] = 4
						pks[k_itemamount] = 10				
					end
				end
			end
		end
	end
		
	if p.huge > 0 and GrowplusEndCheck(p) then
		p.mo.colorized = false
		p.mo.color = p.skincolor
		p.mo.scalespeed = mapobjectscale/TICRATE
		p.mo.destscale = mapobjectscale
		P_RestoreMusic(p)
		pks[k_growshrinktimer] = 0
		p.huge = 0
	end
end

--Eggbomb Fix--
local function noeggroll (mo, mo2)
	if mo2.player
	and (mo2.player.huge > 0)
	and ((not hq_eggkarma.value) or (hq_eggkarma.value and (mo2.player.kartstuff[k_itemtype] or mo2.player.kartstuff[k_roulettetype])))
		return true
	else
		return false
	end
	return
end
addHook("TouchSpecial", noeggroll, MT_EGGMANITEM)

--- Don't Stop Me Now --- 
local function hugeinv(p)
	if p.huge > 0
		K_DoInstashield(p)
		return false
	end
	return
end

---Bless Togen for these Hooks---
addHook("ShouldDamage", function(mo, inflictor, source, damage)
    if not (mo and mo.valid and mo.player) then return end
	local mop, mopks = mo.player, mo.player.kartstuff
	
    if damage < 10000 then
		if mop.huge > 0 then
			if inflictor and inflictor.valid
				if ((inflictor.type == MT_ORBINAUT) 
				or (inflictor.type == MT_ORBINAUT_SHIELD) 
				or (inflictor.type == MT_JAWZ) 
				or (inflictor.type == MT_JAWZ_DUD) 
				or (inflictor.type == MT_JAWZ_SHIELD)
				or (inflictor.type == MT_PLAYER)) --Goddammit, Invincibility
					K_DoInstashield(mop)
					return false
				end
			end
		end
	end
	return
end)
addHook("ShouldExplode", hugeinv)
addHook("ShouldSpin", hugeinv)
addHook("ShouldSquish", hugeinv)

---Item Size Scaling; shoutouts to Titou's Comet weather---
local bigitem = {MT_BANANA, MT_ORBINAUT, MT_JAWZ, MT_JAWZ_DUD, MT_SSMINE, MT_SSMINE_SHIELD, MT_BALLHOG, MT_SINK}
for _,i in pairs(bigitem) do
	addHook("MobjThinker", function(mo)
		if (not hq_huge.value) or (not mo and mo.valid) then return end
		
		if mo.target and mo.target.player and not mo.beeg
			mo.beeg = 1	
			if (mo.target.player.huge)
				mo.scale = (2*mapobjectscale)
			end
		end
		
		if mo.scale == (mapobjectscale*2) then
			local addx = FixedMul(mo.momx, mapobjectscale/2)
			local addy = FixedMul(mo.momy, mapobjectscale/2)
			P_TryMove(mo, (mo.x + addx), (mo.y + addy), mo.z, false)		
			//debug
			//if mo.type == MT_ORBINAUT and not mo.glass
				//mo.health = 1
				//mo.glass = true
			//end
		end
	end, i)
end

---Extended Spinout (from Benji)---
local function K_HQBonk (p)
	if (hq_huge.value and hq_yeet.value) then
		if p.kartstuff[k_spinouttimer] 
			if p.hqspeen 
				p.kartstuff[k_spinouttimer] = $*5/4 //+25%
				p.hqspeen = false
			elseif p.hqboom
				p.kartstuff[k_spinouttimer] = $*3/2 //+50%
				p.mo.momz = $*3/2
				p.hqboom = false
			end
		end
	end

	if p.kartstuff[k_spinouttimer]
		if p.hqspb
			if p.kartstuff[k_spinouttimer]
				if p.kartstuff[k_eggmanexplode]
				or p.kartstuff[k_roulettetype] == 2
					p.kartstuff[k_spinouttimer] = $*3/2 //+50%
					p.mo.momz = $*3/2 //+50%
					K_StripOther(p)
					//print("FUCK YOU")
				end
			end
			p.hqspb = false
		end
	end
end

---The Big Ones---
local function ohhhhbanana (mo)
	local x = mo.x
	local y = mo.y
	local z = mo.z
	local banan = FixedMul(5*FRACUNIT, mo.scale)
	local boffset = FixedMul(FRACUNIT, mo.scale)
	if mo.scale >= (2*mapobjectscale)
	and ((not (cv_weathermod)) or ((cv_weathermod) and ((weathermod.current.id ~= 22) or (weathermod.current.id == 22) and (weathermod.active == false))))
		//print("OHHHH BANANA")
		local split1 = P_SpawnMobj(x, y, z+boffset, MT_BANANA)
		split1.potassium = true
		//split1.momx = FRACUNIT*cos(mo.angle-ANGLE_135)
		split1.momy = FixedMul(banan, cos(mo.angle))
		split1.momz = FixedMul(banan, sin(ANGLE_45))
		local split2 = P_SpawnMobj(x, y, z+boffset, MT_BANANA)
		split2.potassium = true
		split2.momx = FixedMul(-banan, cos(mo.angle))
		//split2.momy = FRACUNIT*sin(mo.angle+ANGLE_135)
		split2.momz = FixedMul(banan, sin(ANGLE_45))
		local split3 = P_SpawnMobj(x, y, z+boffset, MT_BANANA)
		split3.potassium = true
		split3.momx = FixedMul(banan, cos(mo.angle))
		//split3.momy = FixedMul(FixedMul(banan, sin(mo.angle)), cos(ANGLE_45))
		split3.momz = FixedMul(banan, sin(ANGLE_45))
	end
end
addHook("MobjDeath", ohhhhbanana, MT_BANANA)

local function PraiseBeToBanan(mo)
	if not mo and mo.potassium return end
	if mo.potassium == true
		if not P_IsObjectOnGround(mo)
			mo.flags = $ | MF_NOCLIPTHING
		else
			mo.flags = $ & ~MF_NOCLIPTHING
		end
	end
end
addHook("MobjThinker", PraiseBeToBanan, MT_BANANA)

//local function BananDebug(mo)
	//if not mo.potassium
		//mo.scale = 2*mapobjectscale
	//end
//end

//addHook("MobjThinker", BananDebug, MT_BANANA)

--local balltimer = TICRATE/5
--local split1
--local split2
--local split3
--local split4

local function pinball (mo)
	local x = mo.x
	local y = mo.y
	local z = mo.z
	local dis = 40
	local ball = FixedMul((dis*FRACUNIT), mo.scale)
	local balldiff = FixedMul(((2*dis)*FRACUNIT), mo.scale)
	local angdiff = ANGLE_45
	local hqspawn = 0
	if mo.scale >= (2*mapobjectscale)
	and ((not (cv_weathermod)) or ((cv_weathermod) and ((weathermod.current.id ~= 22) or (weathermod.current.id == 22) and (weathermod.active == false))))
		while hqspawn < 2 -- Thank you micenice
		do
			local split = P_SpawnMobj(x+FixedMul((ball-(balldiff*hqspawn)), cos(mo.angle)), y-FixedMul((ball-(balldiff*hqspawn)), sin(mo.angle)), z, MT_ORBINAUT)
			split.movefactor = 64*mapobjectscale
			P_InstaThrust(split, (mo.angle+(ANGLE_157h+(angdiff*hqspawn))), split.movefactor)
		split.color = SKINCOLOR_JAWZ
		hqspawn = $+1
		end
	end
end
addHook("MobjDeath", pinball, MT_ORBINAUT)

local function CheckInvincibilty(p)
	if p.kartstuff[k_roulettetype] 
	or p.kartstuff[k_stolentimer] 
	or p.kartstuff[k_spinouttimer] 
	or p.kartstuff[k_wipeoutslow]
		return true
	else
		return false
	end
end

local function K_Stardust(p)
	if not (hq_sparkle.value) then return end
	
	pks = p.kartstuff
	p.mo.sparkle = $ or 0
	
	//if leveltime > STARTTIME
	//	print("K_Stardust".." IT: "..pks[k_itemtype].." LFIT: "..p.HQLFitem.." IA: "..pks[k_itemamount].." LFIA: "..p.HQLFamount)
	//end

	if p.HQLFitem == 3
	and pks[k_itemamount] < p.HQLFamount
	and not CheckInvincibilty(p) then
		//print("STAR POWER")
		p.mo.sparkle = $ + 351
	end
	p.mo.sparkle = max($-1,0)
	if p.mo.sparkle > 0
		pks[k_invincibilitytimer] = p.mo.sparkle
		//print("timer:"..p.mo.sparkle)
	end
	if not (hq_skittles.value)
		if pks[k_invincibilitytimer] > 0
			if leveltime%(TICRATE/5) == 0
				p.mo.color = SKINCOLOR_WHITE
				p.mo.colorized = true
			else
				p.mo.color = p.skincolor
				p.mo.colorized = false
			end
		else
			if not (p.huge)
				p.mo.color = p.skincolor
				p.mo.colorized = false
			end
		end
	end
	
	p.HQLFitem = pks[k_itemtype]
	p.HQLFamount = pks[k_itemamount]
			
	if pks[k_spinouttimer] > 0
	or pks[k_wipeoutslow] > 0
		p.mo.sparkle = 0
		pks[k_invincibilitytimer] = 0
	end
end

---Huge Balls: Thank you Tyron---
local function K_HQRefund(p)
	if not (hq_huge.value and hq_orbigift.value) return end
	
	pks = p.kartstuff
	//if leveltime > STARTTIME
	//	print("K_HQRefund".." IT: "..pks[k_itemtype].." LFIT: "..p.HQLFitem.." IA: "..pks[k_itemamount].." LFIA: "..p.HQLFamount)
	//end
	if p.HQLFitem == 11
	and pks[k_itemamount] == 0 
	and (not pks[k_roulettetype]) 
	and (not pks[k_stolentimer])
		pks[k_itemblink] = TICRATE/2
		pks[k_itemtype] = 6
		pks[k_itemamount] = 1
		S_StartSound(nil, sfx_itpick, p)
		p.sphere = true
	end
	if p.sphere == true
		if pks[k_itemamount] == 0
			p.sphere = nil
		end
		if p.huge == 0
			K_StripItems(p)
			p.sphere = nil
		end
	end
end

--- Sonic 1 throwback ---
local function classicsonic(mo)
	if (not hq_sparkle.value) or hq_skittles.value then return end
	if not (mo and mo.valid) then return end

	if mo.target.player.kartstuff[k_invincibilitytimer] > 1
		mo.color = SKINCOLOR_WHITE
		mo.colorized = true
	end
end
addHook("MobjThinker", classicsonic, MT_SPARKLETRAIL)


---We don't waste MT in this house--
local function K_DriftboostJump(p)
	if not (hq_mtstore.value) then return end
	
	pks = p.kartstuff
	
	if pks[k_driftboost] > 0
		//print("DriftBoost:"..pks[k_driftboost])
		if ((not P_IsObjectOnGround(p.mo))
        or (not acrobatics and pks[k_sneakertimer])
        or (acrobatics and pks[k_sneakertimer] > 0 and p.tricksneakerbuffer > 0))
		and p.playerstate == PST_LIVE
			pks[k_driftboost] = $+1
		end
	end
end

local function K_HQNyoom(mo)
	if not (hq_mtstore.value) or not (mo and mo.valid) then return end
	
	if mo.target and mo.target.player then
        if mo.target.player.kartstuff[k_driftboost] > 0
        and ((not acrobatics and mo.target.player.kartstuff[k_sneakertimer] > 0)
        or (acrobatics and mo.target.player.kartstuff[k_sneakertimer] > 0 and mo.target.player.tricksneakerbuffer > 0))
			mo.color = SKINCOLOR_HANDHELD
			mo.colorized = true
		else
			mo.colorized = false
		end
	end
end
addHook("MobjThinker", K_HQNyoom, MT_FASTLINE)

--LOOK ALIVE (from Benji)--
local sfxnum, localplayer = 0, nil
local function STOPTHIS(p, this)
	if (sfxnum != this and S_SoundPlaying(p.mo, this)) then
		S_StopSoundByID(p.mo, this)
	end
end
local function UpdateGrowAlarmSound(p)
	if not (hq_huge.value) then return end
	
	if p.mo.health > 0 and p.huge > 0 and localplayer != p 
	and p.kartstuff[k_invincibilitytimer] == 0 //Prioritize Grow
		if (CV_FindVar("kartinvinsfx").value)
			sfxnum = sfx_hqa
		else
			sfxnum = sfx_hq
		end
	else
		sfxnum = 0
	end
	if (sfxnum != 0) and (not S_SoundPlaying(p.mo, sfxnum))
		S_StartSound(p.mo, sfxnum)
		S_StartSound(p.mo, sfxnum)
	end
	STOPTHIS(p, sfx_hqa)
	STOPTHIS(p, sfx_hq)
end

---HUGE QUEST---
addHook("MapLoad", do
	for p in players.iterate
		p.hqready = nil
	end
end)

addHook("ThinkFrame", do
	for p in players.iterate
		if not p.mo or not p.mo.valid continue end
		if not (p.hqready) then
			hq_init(p)
		end
		if leveltime <= STARTTIME or p.spectator continue end
		
		-- Player stuff
		K_DriftboostJump(p)
		K_HugeQuest(p)
		K_HQBonk(p)
		K_HQRefund(p)
		K_Stardust(p)
		UpdateGrowAlarmSound(p)
		
		if HOSTMOD then
			if p.huge > 0 and p.huge <= 3*TICRATE
				local r = p.huge / TICRATE + 1
				local d = r*2 + 1
				if (CV_FindVar("powerflash").value) then
					if (leveltime % d < r) and (CV_FindVar("powerflash").value)
						if hq_offroad.value
							p.mo.color = SKINCOLOR_LAVENDER
						else
							p.mo.color = SKINCOLOR_JAWZ
						end
						p.mo.colorized = true
					else
						p.mo.color = p.skincolor
						p.mo.colorized = false
					end
				end
				if not (p.huge % TICRATE) and (CV_FindVar("powersound").value) then
					S_StartSound(nil, sfx_s242, p)
				end
			end
		end
	end
end)


---Hitfeed Support: Thank you Snu---
local function hqSquish(p, inf, s)
	if not (p.mo and p.mo.valid) or not (hq_huge.value) then return end
	
	if (hitfeed)
		if inf
			if inf.valid and inf.player and (inf.player.huge > 0)
				if not (s and s.player) return end
				local s_hq = {{s.player.name, s.hf_overridenamecolor or s.player.skincolor}, {skins[s.skin].facemmap, s.player.skincolor}, s.player}
				local v_hq = {{p.name, p.mo.hf_overridenamecolor or p.skincolor}, {skins[p.mo.skin].facemmap, p.skincolor}, p}
				if (s_hq[3] == v_hq[3]) then s = nil end	-- source == victim, remove source
				local icon_hq = "K_HMGROW"
				HF_SendHitMessage(s_hq, v_hq, icon_hq)
			end
		end
	end
end
addHook("PlayerSquish", hqSquish)

---YEET (from Benji)---
addHook("PlayerSpin", function(p, inf, source)
	if not (inf and inf.valid) or not (hq_yeet.value) then return end
	
	if inf.scale == (mapobjectscale*2) 
	and ((inf.type == MT_ORBINAUT) 							
	or (inf.type == MT_ORBINAUT_SHIELD) 
	or (inf.type == MT_JAWZ) 
	or (inf.type == MT_JAWZ_DUD) 
	or (inf.type == MT_JAWZ_SHIELD)
	or (inf.type == MT_BANANA) 
	or (inf.type == MT_BANANA_SHIELD) 
	or (inf.type == MT_BALLHOG))
		//print("ow")
		p.hqspeen = true
	end
end)
addHook("PlayerExplode", function(p, inf, source)
	if not (inf and inf.valid) then return end
	
	if hq_yeet.value
		if inf.scale == (mapobjectscale*2) and ((inf.type == MT_SSMINE) or (inf.type == MT_SSMINE_SHIELD) or (inf.type == MT_MINEEXPLOSION))
			//print("ow")
			p.hqboom = true
		end
	end
	
	if (inf.type == MT_SPBEXPLOSION and inf.extravalue1)
		p.hqspb = true
	end
end)

hud.add(function(v, p, c)
  localplayer = p
end)